{  umatrix2 -- examples for pascal units for matrix operations (real and complex)
   Version 20210727
   Copyright (C) 2000-2021 Stefan Ziegenbalg
  
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 3 as
   published by the Free Software Foundation.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, see http://www.gnu.org/licenses/.
!}

uses ucmatrix2;
var a,q,r : matrix;

begin
    am2(a,rmatrix(4,4, [1,0,0,0, 2,3,0,0, 4,5,0,0, 7,8,9,10]));
    am(a,a*trans(a));
    qr2(a,q,r);

    writeln('A=');
    printmatrix(a);
    writeln;

    writeln('Q=');
    printmatrix(q);
    writeln;

    writeln('R=');
    printmatrix(r);
    writeln;

    writeln('Q^T*Q=');
    printmatrix(trans(q)*q);
    writeln;

    writeln('A*R=');
    printmatrix(a*r);
    writeln;

    writeln('R*Q^T=');
    printmatrix(q*trans(r));
    writeln;

    writeln('R*Q^T*A=');
    printmatrix(r*trans(q)*a);
    writeln;

    free(a);
    free(q);
    free(r);
end.
